"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresApolloPlugin = void 0;
const postgres_1 = require("@cuillere/postgres");
const promise_1 = require("@cuillere/core/lib/utils/promise");
function PostgresApolloPlugin(options) {
    var _a;
    const contextKey = (_a = options.contextKey) !== null && _a !== void 0 ? _a : 'cuillere';
    return {
        requestDidStart() {
            let didEncounterErrors = false;
            return {
                // WORKAROUND: https://github.com/EmrysMyrddin/cuillere/issues/25
                didEncounterErrors() {
                    didEncounterErrors = true;
                },
                executionDidStart(reqCtx) {
                    const isMutation = reqCtx.operation.operation === 'mutation';
                    if (contextKey in reqCtx.context && !isMutation)
                        return undefined;
                    const [task, resolve, reject] = promise_1.executablePromise();
                    postgres_1.getClientManager({ ...options, transactionManager: isMutation ? options.transactionManager : 'none' })
                        .execute(reqCtx.context[contextKey] = {}, () => task)
                        .catch(() => { });
                    return () => {
                        if (didEncounterErrors)
                            reject(true);
                        else
                            resolve();
                    };
                },
            };
        },
    };
}
exports.PostgresApolloPlugin = PostgresApolloPlugin;
//# sourceMappingURL=index.js.map